----------------------------------------------------------
--		Sample Filter Script			--
--							--
--  Author:	Nathaniel Meyer				--
--  Email:	nate@nutty.ca				--
--  Copyright:	Nutty Productions			--
--  Website:	http://www.nutty.ca			--
--							--
--  Desc:	This is a sample script that acquires	--
--		image information and reverses the	--
--		colour order.				--
--							--
----------------------------------------------------------


-- Includes --
require "scripts/image"
--------------


-- Globals --
local width, height, channels	= GetImage();
local iWidth			= width - 1;
local iHeight			= height - 1;
local progress			= math.floor(height / 10);
-------------


-- Local Members --
local opacity	= 0.0;
local r, g, b;
local dst	= Colour(0, 0, 0, 0);
local src	= Colour(0, 0, 0, 0);
local blend	= Colour(0, 0, 0, 0);
-------------------


-- Filter Image --
for y = 0, iHeight do
	for x = 0, iWidth do
		-- Update Image Data
		dst.r, dst.g, dst.b = GetPixel(x, y);
		src.r = dst.r;
		src.g = dst.g;
		src.b = dst.b;

		-- Darken Blends --
		--imgDarken(dst, src, blend);
		--imgMultiply(dst, src, blend);
		--imgColourBurn(dst, src, blend);
		--imgLinearBurn(dst, src, blend);

		-- Lighten Blends --
		--imgLighten(dst, src, blend);
		--imgScreen(dst, src, blend);
		--imgColourDodge(dst, src, blend);
		--imgLinearDodge(dst, src, blend);

		-- Mix Blends --
		--imgOverlay(dst, src, blend);
		--imgSoftLight(dst, src, blend);
		--imgHardLight(dst, src, blend);
		--imgVividLight(dst, src, blend);
		--imgLinearLight(dst, src, blend);
		--imgPinLight(dst, src, blend);

		-- Logic Blends --
		--imgDifference(dst, src, blend);
		imgExclusion(dst, src, blend);

		SetPixel(x, y, blend.r, blend.g, blend.b);

		-- Update Progress
		if math.mod(y, progress) == 0 then
			SetProgress((y / height) * 100);
		end;
	end
end
