----------------------------------------------------------
--		Infrared Script				--
--							--
--  Author:	Nathaniel Meyer				--
--  Email:	nate@nutty.ca				--
--  Copyright:	Nutty Productions			--
--  Website:	http://www.nutty.ca			--
--							--
--  Desc:	Convert an RGB image to infrared	--
--							--
----------------------------------------------------------


-- Local Members --
local width, height, channels	= GetImage();
local iWidth			= width - 1;
local iHeight			= height - 1;
local progress			= math.floor(height / 10);
local r, g, b;
local gray;
-------------


-- Filter Image --
for y = 0, iHeight do
	for x = 0, iWidth do
		-- Update Image Data
		r, g, b = GetPixel(x, y);
		gray = (r + g + b) / 3;

		-- Step 1: Dark becomes bright, bright becomes dark
		--gray = 255 - gray;

		if ( (gray > 100) and (gray < 200) ) then
			gray = gray / 2;
		end

		-- Red
		if ( (r > g) and (r > b) ) then
			gray = math.max(0, gray * (gray / r));
			SetPixel(x, y, gray, gray, gray);
		-- Green
		elseif ( (g > r) and (g > b) ) then
			gray = math.min(255, g * (g / gray));
			SetPixel(x, y, gray, gray, gray)
		-- Blue
		elseif ( (b > r) and (b > g) ) then
			gray = math.max(0, gray * (gray / b));
			SetPixel(x, y, gray - gray * 0.5, math.max(0, b - b * 0.5), math.max(0, g - g * 0.5));
		else
			SetPixel(x, y, gray, gray, gray);
		end

		-- Update Progress
		if math.mod(y, progress) == 0 then
			SetProgress((y / height) * 100);
		end;
	end
end
