--------------------------------------------------
--		Sprite Transparency Script				--
--												--
--  Author:		Nathaniel Meyer					--
--  Email:		nate@nutty.ca					--
--  Copyright:	Nutty Productions				--
--  Website:	http://www.nutty.ca				--
--												--
--  Desc:	Some sprites use a background		--
--			colour that is masked at runtime.	--
--			This script, along with the 		--
--			Force RGBA option, helps to create	--
--			an alpha channel for use with 32	--
--			bit images.							--
--												--
--------------------------------------------------


-- Local Members --
local width, height, channels	= GetImage();
local iWidth			= width - 1;
local iHeight			= height - 1;
local progress			= math.floor(height / 10);
local r, g, b;
-------------


-- Filter Image --
for y = 0, iHeight do
	for x = 0, iWidth do
		-- Process only RGBA images
		if channels == 4 then
			r, g, b, a = GetPixel(x, y);
			if ( (r == 111) and (g == 79) and (b == 51) ) then
				a = 0;
			end
			SetPixel(x, y, r, g, b, a);
		end

		-- Update Progress
		if math.mod(y, progress) == 0 then
			SetProgress((y / height) * 100);
		end;
	end
end
